<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: SR_GuiaRemisionDet.xml */
/* Generado: 2021-05-03 06:53:22 */

/* Mantenimiento de los registros de la tabla SR_GuiaRemisionDet */
abstract class BaseSR_GuiaRemisionDetDP extends SR_GuiaRemisionDetBV
{
    /* Constructor ( Establece los valores desde un objeto SR_GuiaRemisionDetBN ) */
    public function __construct( SR_GuiaRemisionDetBN $o_SR_GuiaRemisionDetBN = null )
    {
        parent::__construct();
        if ( !is_null( $o_SR_GuiaRemisionDetBN ) )
        {
            $this->setByBN( $o_SR_GuiaRemisionDetBN );
        }
    }

    public $b_Debug = false;

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Establece los valores desde un objeto SR_GuiaRemisionDetBN */
    public function setByBN( SR_GuiaRemisionDetBN $o_SR_GuiaRemisionDetBN )
    {
        if ( !is_null( $o_SR_GuiaRemisionDetBN->getGuiaRemisionDetId() ) )
        {
            $this->setGuiaRemisionDetId( $o_SR_GuiaRemisionDetBN->getGuiaRemisionDetId() );
        }
        if ( !is_null( $o_SR_GuiaRemisionDetBN->getGuiaRemisionId() ) )
        {
            $this->setGuiaRemisionId( $o_SR_GuiaRemisionDetBN->getGuiaRemisionId() );
        }
        if ( !is_null( $o_SR_GuiaRemisionDetBN->getMovimientoId() ) )
        {
            $this->setMovimientoId( $o_SR_GuiaRemisionDetBN->getMovimientoId() );
        }
        if ( !is_null( $o_SR_GuiaRemisionDetBN->getIdItem() ) )
        {
            $this->setIdItem( $o_SR_GuiaRemisionDetBN->getIdItem() );
        }
        if ( !is_null( $o_SR_GuiaRemisionDetBN->getDescripcion() ) )
        {
            $this->setDescripcion( $o_SR_GuiaRemisionDetBN->getDescripcion() );
        }
        if ( !is_null( $o_SR_GuiaRemisionDetBN->getSecuencia() ) )
        {
            $this->setSecuencia( $o_SR_GuiaRemisionDetBN->getSecuencia() );
        }
        if ( !is_null( $o_SR_GuiaRemisionDetBN->getProFinalId() ) )
        {
            $this->setProFinalId( $o_SR_GuiaRemisionDetBN->getProFinalId() );
        }
        if ( !is_null( $o_SR_GuiaRemisionDetBN->getProFinalDetId() ) )
        {
            $this->setProFinalDetId( $o_SR_GuiaRemisionDetBN->getProFinalDetId() );
        }
        if ( !is_null( $o_SR_GuiaRemisionDetBN->getIdUnidad() ) )
        {
            $this->setIdUnidad( $o_SR_GuiaRemisionDetBN->getIdUnidad() );
        }
        if ( !is_null( $o_SR_GuiaRemisionDetBN->getCantidad() ) )
        {
            $this->setCantidad( $o_SR_GuiaRemisionDetBN->getCantidad() );
        }
        if ( !is_null( $o_SR_GuiaRemisionDetBN->getPesoUnitario() ) )
        {
            $this->setPesoUnitario( $o_SR_GuiaRemisionDetBN->getPesoUnitario() );
        }
        if ( !is_null( $o_SR_GuiaRemisionDetBN->getPesoTotal() ) )
        {
            $this->setPesoTotal( $o_SR_GuiaRemisionDetBN->getPesoTotal() );
        }
        if ( !is_null( $o_SR_GuiaRemisionDetBN->getCantidadPendienteDevolucion() ) )
        {
            $this->setCantidadPendienteDevolucion( $o_SR_GuiaRemisionDetBN->getCantidadPendienteDevolucion() );
        }
        if ( !is_null( $o_SR_GuiaRemisionDetBN->getDiasMinimoAlquiler() ) )
        {
            $this->setDiasMinimoAlquiler( $o_SR_GuiaRemisionDetBN->getDiasMinimoAlquiler() );
        }
        if ( !is_null( $o_SR_GuiaRemisionDetBN->getPrecioUnitarioAlquilerLocal() ) )
        {
            $this->setPrecioUnitarioAlquilerLocal( $o_SR_GuiaRemisionDetBN->getPrecioUnitarioAlquilerLocal() );
        }
        if ( !is_null( $o_SR_GuiaRemisionDetBN->getPrecioUnitarioAlquilerDolares() ) )
        {
            $this->setPrecioUnitarioAlquilerDolares( $o_SR_GuiaRemisionDetBN->getPrecioUnitarioAlquilerDolares() );
        }
        if ( !is_null( $o_SR_GuiaRemisionDetBN->getPrecioUnitarioVentaLocal() ) )
        {
            $this->setPrecioUnitarioVentaLocal( $o_SR_GuiaRemisionDetBN->getPrecioUnitarioVentaLocal() );
        }
        if ( !is_null( $o_SR_GuiaRemisionDetBN->getPrecioUnitarioVentaDolares() ) )
        {
            $this->setPrecioUnitarioVentaDolares( $o_SR_GuiaRemisionDetBN->getPrecioUnitarioVentaDolares() );
        }
    }

    /* Graba un nuevo registro */
    public function save()
    {
        $this->validateRecord();
        $o_SR_GuiaRemisionDetFN = new SR_GuiaRemisionDetFN();
        $o_SR_GuiaRemisionDetBN = $o_SR_GuiaRemisionDetFN->selectByPk( $this->getGuiaRemisionDetId() );
        if ( is_null( $o_SR_GuiaRemisionDetBN ) )
        {
            $s_SQLQuery1 = "INSERT INTO SR_GuiaRemisionDet ( ";
            $s_SQLQuery2 = "VALUES ( ";
            $s_Separator = "";
            if ( !is_null( $this->getGuiaRemisionDetId() ) )
            {
                $s_SQLQuery1 .= $s_Separator."GuiaRemisionDetId";
                $s_SQLQuery2 .= $s_Separator."".$this->getGuiaRemisionDetId()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getGuiaRemisionId() ) )
            {
                $s_SQLQuery1 .= $s_Separator."GuiaRemisionId";
                $s_SQLQuery2 .= $s_Separator."'".$this->getGuiaRemisionId()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getMovimientoId() ) )
            {
                $s_SQLQuery1 .= $s_Separator."MovimientoId";
                $s_SQLQuery2 .= $s_Separator."".$this->getMovimientoId()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdItem() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdItem";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdItem()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDescripcion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Descripcion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getDescripcion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getSecuencia() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Secuencia";
                $s_SQLQuery2 .= $s_Separator."'".$this->getSecuencia()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getProFinalId() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ProFinalId";
                $s_SQLQuery2 .= $s_Separator."".$this->getProFinalId()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getProFinalDetId() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ProFinalDetId";
                $s_SQLQuery2 .= $s_Separator."".$this->getProFinalDetId()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdUnidad() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdUnidad";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdUnidad()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCantidad() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Cantidad";
                $s_SQLQuery2 .= $s_Separator."".$this->getCantidad()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPesoUnitario() ) )
            {
                $s_SQLQuery1 .= $s_Separator."PesoUnitario";
                $s_SQLQuery2 .= $s_Separator."".$this->getPesoUnitario()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPesoTotal() ) )
            {
                $s_SQLQuery1 .= $s_Separator."PesoTotal";
                $s_SQLQuery2 .= $s_Separator."".$this->getPesoTotal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCantidadPendienteDevolucion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."CantidadPendienteDevolucion";
                $s_SQLQuery2 .= $s_Separator."".$this->getCantidadPendienteDevolucion()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDiasMinimoAlquiler() ) )
            {
                $s_SQLQuery1 .= $s_Separator."DiasMinimoAlquiler";
                $s_SQLQuery2 .= $s_Separator."".$this->getDiasMinimoAlquiler()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioUnitarioAlquilerLocal() ) )
            {
                $s_SQLQuery1 .= $s_Separator."PrecioUnitarioAlquilerLocal";
                $s_SQLQuery2 .= $s_Separator."".$this->getPrecioUnitarioAlquilerLocal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioUnitarioAlquilerDolares() ) )
            {
                $s_SQLQuery1 .= $s_Separator."PrecioUnitarioAlquilerDolares";
                $s_SQLQuery2 .= $s_Separator."".$this->getPrecioUnitarioAlquilerDolares()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioUnitarioVentaLocal() ) )
            {
                $s_SQLQuery1 .= $s_Separator."PrecioUnitarioVentaLocal";
                $s_SQLQuery2 .= $s_Separator."".$this->getPrecioUnitarioVentaLocal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioUnitarioVentaDolares() ) )
            {
                $s_SQLQuery1 .= $s_Separator."PrecioUnitarioVentaDolares";
                $s_SQLQuery2 .= $s_Separator."".$this->getPrecioUnitarioVentaDolares()."";
                $s_Separator = ", ";
            }
            $s_SQLQuery = $s_SQLQuery1." ) ".$s_SQLQuery2." );";
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
        }
        else
        {
            throw new Exception( "El id ya esta registrado." );
        }
        return true;
    }

    /* Actualiza los datos del registro */
    public function update()
    {
        $this->validateRecord();
        if ( true )
        {
            $s_SQLQuery = "UPDATE SR_GuiaRemisionDet SET ";
            $s_Separator = "";
            if ( !is_null( $this->getGuiaRemisionId() ) )
            {
                $s_SQLQuery .= $s_Separator."GuiaRemisionId = '".$this->getGuiaRemisionId()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getMovimientoId() ) )
            {
                $s_SQLQuery .= $s_Separator."MovimientoId = ".$this->getMovimientoId()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdItem() ) )
            {
                $s_SQLQuery .= $s_Separator."IdItem = '".$this->getIdItem()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDescripcion() ) )
            {
                $s_SQLQuery .= $s_Separator."Descripcion = '".$this->getDescripcion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getSecuencia() ) )
            {
                $s_SQLQuery .= $s_Separator."Secuencia = '".$this->getSecuencia()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getProFinalId() ) )
            {
                $s_SQLQuery .= $s_Separator."ProFinalId = ".$this->getProFinalId()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getProFinalDetId() ) )
            {
                $s_SQLQuery .= $s_Separator."ProFinalDetId = ".$this->getProFinalDetId()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdUnidad() ) )
            {
                $s_SQLQuery .= $s_Separator."IdUnidad = ".$this->getIdUnidad()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCantidad() ) )
            {
                $s_SQLQuery .= $s_Separator."Cantidad = ".$this->getCantidad()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPesoUnitario() ) )
            {
                $s_SQLQuery .= $s_Separator."PesoUnitario = ".$this->getPesoUnitario()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPesoTotal() ) )
            {
                $s_SQLQuery .= $s_Separator."PesoTotal = ".$this->getPesoTotal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCantidadPendienteDevolucion() ) )
            {
                $s_SQLQuery .= $s_Separator."CantidadPendienteDevolucion = ".$this->getCantidadPendienteDevolucion()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDiasMinimoAlquiler() ) )
            {
                $s_SQLQuery .= $s_Separator."DiasMinimoAlquiler = ".$this->getDiasMinimoAlquiler()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioUnitarioAlquilerLocal() ) )
            {
                $s_SQLQuery .= $s_Separator."PrecioUnitarioAlquilerLocal = ".$this->getPrecioUnitarioAlquilerLocal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioUnitarioAlquilerDolares() ) )
            {
                $s_SQLQuery .= $s_Separator."PrecioUnitarioAlquilerDolares = ".$this->getPrecioUnitarioAlquilerDolares()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioUnitarioVentaLocal() ) )
            {
                $s_SQLQuery .= $s_Separator."PrecioUnitarioVentaLocal = ".$this->getPrecioUnitarioVentaLocal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPrecioUnitarioVentaDolares() ) )
            {
                $s_SQLQuery .= $s_Separator."PrecioUnitarioVentaDolares = ".$this->getPrecioUnitarioVentaDolares()."";
                $s_Separator = ", ";
            }
            $s_SQLQuery .= " WHERE  GuiaRemisionDetId = ".$this->getGuiaRemisionDetId().";";
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }

            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Elimina el registro */
    public function delete()
    {
        $s_SQLQuery = "DELETE FROM SR_GuiaRemisionDet WHERE  GuiaRemisionDetId = ".$this->getGuiaRemisionDetId().";";
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        $o_Resource = Conexion::getConexion();
        $o_Statement = $o_Resource->createStatement();
        $o_Statement->executeQuery( $s_SQLQuery );
        return true;
    }

}
?>